import java.util.*;
import java.util.LinkedList;
import org.opencv.core.Core;
import org.opencv.core.Mat;
import org.opencv.core.MatOfRect;
import org.opencv.core.Point;
import org.opencv.core.Rect;
import org.opencv.core.Scalar;
import org.opencv.core.Size;
import org.opencv.highgui.HighGui;
import org.opencv.imgproc.Imgproc;
import org.opencv.objdetect.CascadeClassifier;
import org.opencv.videoio.VideoCapture;
import processing.sound.*;
Alphabet a = new Alphabet();//neues Alphabetobjekt, hier wird das Angezeigte Alphabet verwaltet und manipuliert
boolean start = false; //Starwert, wird bei drücken von "Enter" auf true gesetzt
SoundFile sound;//sound für die Sounsaugabe für auditives Feedback
int noe = 2;//numberOfEyes
int noeprev = 2;// vorherige numberOfEyes
int timer = 0;// timer für die dauer, die eine bestimmte Anzahl von Augen vorhanden ist
char x = 'ß'; // der letzte buchstabe, der dann dem Ausgabestring hinzugefügt wird
String ausgabe="";//ausgabe String beinhaltet alle eingaben 
int i = 0;
ObjectDetection y = new ObjectDetection();//erstellen eines Objectdetection Objektes
String filenameEyesCascade = "C:/Users/dlugo/Documents/Processing/libraries/opencvold/src/haarcascades/haarcascade_eye.xml";
//location für die "haarcascade_eye.xml" notwendig für den Programmablauf. Befindet sich in dem opencv library ordener
int cameraDevice = 0;//angabe der Kamera meistens 0 oder 1
VideoCapture capture;
Mat frame; 
CascadeClassifier eyesCascade;
void setup() {
  frameRate(10);
  sound = new SoundFile(this, "sound.mp3");
  System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
  capture = new VideoCapture(cameraDevice);
  frame = new Mat();
  eyesCascade = new CascadeClassifier(filenameEyesCascade);
  size(1100, 200);
}
void draw() {
  if (!start) {
    //darstellung des Startbildschirms
    background(255);
    fill(0);
    textSize(16);
    text("Position 'I2Text' window near webcam and make sure the webcam detects both eyes.\nUse 'CameraFeedback' window for that.\nThere are 2 sides to choose from by either holding one eye shut(left) or both eyes shut(right).\nBy choosing a side the letters from the other side will be removed and the remaing ones split between both sides.\nIf only one letter on either side is left and this side gets choses the given letter will be saved into the current sentence variable.\nSelect 'I2Text' window and press 'ENTER' to start program.", 0, height/4);
  } else {
    //darstellugn des Interfaces
    background(255);
    fill(0);
    line(width/2, 0, width/2, height);
    stroke(0);
    textSize(32);
    text("Hold one eye shut", 0, height/4);
    text("Hold both eyes shut", width/2, height/4);
    text("Current Sentence: "+ausgabe, 0, height);
    text(a.getCharsLeft(), 0, height/2);
    text(a.getCharsRight(), width/2, height/2);
  }
  if (x !='ß')
  {
    ausgabe+=x;
    x='ß';
    a = new Alphabet();
  }
  
  capture.read(frame);
  y.detectAndDisplay(frame, eyesCascade);
  noe = y.numberOfEyes;
  System.out.println(noe);
  //manueller programmstart mit entertaste. fenster "I2Text" muss nach programminitialisierung ausgewählt werden und "Enter" gedrückt werden
  if (start) {
    // hier geschieht die Auswahllogik der jeweiliges seite. Entweder ein auge geschlossen oder beide augen geschlossen rüfen nach einer gewissen Zeitüberschreitung die entsprechende funktiona auf das Alphabet objekt auf. Ausßerdem wird der Timer bei einer eingabe auf -10 gesetzt um doppeleingaben zu vermeiden.
    // bei Änderung der augenzahl wird der timer auf 0 gesetzt. Diese unterscheidung verhindert, sowohl doppeneingaben als auch zu lange wartezeiten, bei falscherkennung
    if (noe == noeprev) {
      timer++;
    } else {
      timer = 0;
    } 
    if (timer > 5 && noe==1) {
      sound.play();
      x =a.chooseSide(1);
      timer = -10;
    }
    if (timer > 5 && noe==0) {
      sound.play();
      x =a.chooseSide(-1);
      timer = -10;
    }
  }
  //setzen der vorherigen augenanzahl auf die aktuelle
  noeprev = noe;
}
//setzen des werden start auf true beim drücken der entertaste. fenster "I2Text" muss im Vordergrund und ausgewählt sein.
void keyPressed() {
  if (keyCode == ENTER) {
    start = true;
  }
}
