import java.util.*;
import org.opencv.core.Mat;
import org.opencv.core.MatOfRect;
import org.opencv.core.Rect;
import org.opencv.highgui.HighGui;
import org.opencv.imgproc.Imgproc;
import org.opencv.objdetect.CascadeClassifier;
//modifizierte version des beispiels für den cascade classifier von 'https://docs.opencv.org/3.4/db/d28/tutorial_cascade_classifier.html'
class ObjectDetection {
  public int numberOfEyes;
  public void detectAndDisplay(Mat frame, CascadeClassifier eyesCascade) {
    Mat frameGray = new Mat();
    Imgproc.cvtColor(frame, frameGray, Imgproc.COLOR_BGR2GRAY);
    Imgproc.equalizeHist(frameGray, frameGray);
    MatOfRect eyes = new MatOfRect();
    // der 4. parameter bestimmt die "confidence" des programms, je niedriger der wert desto wahrscheinlicher werden andere objekte als augen wahrgenommen. je höher, desto unwahrscheinlicher werden false positives aber dafür werden false negatives wahrscheinlicher. 
    //Dieser wert muss gegebenenfalls ob der verwendeten kamera und den lichtverhältnissen verändert werden. werte zwischen 20 und 100 sind erprobt alles dadrunter und drüber haben keine gute ergebnisse in meinem Setup erreicht.
    eyesCascade.detectMultiScale(frameGray, eyes, 1.1, 40);
    List<Rect> listOfEyes = eyes.toList();
    //zählen der anzahl der Augen in der Augenliste
    numberOfEyes = listOfEyes.size();
    //Zeichnung der K´eise, wo sich die augen befinden
    for (Rect eye : listOfEyes) {
      Point eyeCenter = new Point( eye.x + eye.width / 2, eye.y + eye.height / 2);
      int radius = (int) Math.round((eye.width + eye.height) * 0.25);
      Imgproc.circle(frame, eyeCenter, radius, new Scalar(255, 0, 0), 4);
    }
    //Darstellen des CameraFeedback fensers
    HighGui.imshow("CameraFeedback", frame);
    HighGui.waitKey(1);
  }
}
